#include <stdio.h>
#include <string.h>
#include <iostream>
#include "util.h"

/**************************************************************************
 *** un rectangle
 **************************************************************************/
SWFShape *
a_rectangle (int w, int h,
             int r, int g, int b)
{
    SWFShape *s = new SWFShape ();

    s->setLine (1, 0, 0, 0);
    s->setRightFill (s->addSolidFill (r, g, b));
    s->drawLine (w, 0);
    s->drawLine (0, h);
    s->drawLine (-w, 0);
    s->drawLine (0, -h);

    return s;
}

/**************************************************************************
 *** un bouton
 **************************************************************************/
SWFButton *
a_button (int largeur, int hauteur, int ecart,
          char *action, char *etiquette)
{
    SWFFont *font = new SWFFont ("HelmetCondensed-Bold.fdb");
    SWFText *t = new SWFText ();
    t->setFont (font);
    t->setColor (0, 0, 0);
    t->setHeight (hauteur - 2 * ecart);
    float offset = (largeur - t->getWidth (etiquette)) / 2;
    t->moveTo (offset, hauteur - 1.5 * ecart);
    if (offset < 0)
        std::cerr << "Attention : l'tiquette [" << etiquette << "] est trop large (" << 
            t->getWidth (etiquette) << ">" << largeur << ")." << std::endl;
    t->addString (etiquette);

    SWFButton *b = new SWFButton ();
    b->addShape (t, SWFBUTTON_UP | SWFBUTTON_OVER | SWFBUTTON_DOWN);
    b->addShape (a_rectangle (largeur, hauteur, 210, 210, 220), 
                 SWFBUTTON_UP | SWFBUTTON_HIT);
    b->addShape (a_rectangle (largeur, hauteur, 220, 220, 250),
                 SWFBUTTON_OVER);
    b->addShape (a_rectangle (largeur, hauteur, 190, 190, 220), 
                 SWFBUTTON_DOWN);
    b->addAction (new SWFAction (action), 
                  SWFBUTTON_MOUSEUP);
    return b;
}

/**************************************************************************
 *** a caption
 **************************************************************************/
SWFText *
a_caption (char *text)
{
    SWFText *caption = new SWFText ();
    SWFFont *font = new SWFFont ("HelmetCondensed-Bold.fdb");
    caption->setFont (font);
    caption->setColor (0, 0, 0);
    caption->setHeight (15);
    caption->addString (text);
    return caption;
}

/**************************************************************************
 *** le robot
 **************************************************************************/
SWFSprite *
the_robot ()
{
    SWFSprite *robot   = new SWFSprite ();
    SWFButton *robot_b = new SWFButton ();
    SWFShape  *s;
    SWFDisplayItem *di;

    s = new SWFShape ();
    s->setLine (2, 134, 169, 0);
    s->movePenTo (6, 7); // chenille haut
    s->drawLine (14, 0);
    s->movePenTo (6, 23); // chenille bas
    s->drawLine (14, 0);
    s->movePenTo (12, 15); // canon
    s->drawLine (1, 1);
    s->drawLine (1, -1);
    s->drawLine (-1, -1);
    s->drawLine (-1, 1);
    s->drawLine (13, 0);
    s->setLine (4, 134, 169, 0);
    s->movePenTo (19, 12); // corps
    s->drawCurve (0, -2, -3, 0);
    s->drawLine (-5, 0);
    s->drawCurve (-4, 0, 0, 3);
    s->drawLine (0, 4);
    s->drawCurve (0, 3, 4, 0);
    s->drawLine (5, 0);
    s->drawCurve (3, 0, 0, -2);

    robot_b->addShape (s, SWFBUTTON_UP | SWFBUTTON_DOWN | SWFBUTTON_OVER);

    s = new SWFShape ();
    SWFFill   *f = s->addSolidFill (0, 0, 0);
    s->setLeftFill (f);    
    s->movePen (6, 7);
    s->drawLine (0, 16);
    s->drawLine (19, 0);
    s->drawLine (0, -16);
    s->drawLine (-19, 0);
    robot_b->addShape (s, SWFBUTTON_HIT);
    
    robot_b->addAction (new SWFAction("\n\
if (! _root.UI_playing)\n\
 {\n\
    _root.UI_dragging = true;\n\
}"),
                      SWFBUTTON_MOUSEDOWN);   

    robot->add (robot_b);
    robot->nextFrame ();

    // Un mta-robot pour faciliter les rotations
    SWFSprite *mr = new SWFSprite ();

    di = mr->add (robot);
    mr->add (new SWFAction ("stop ();"));
    mr->nextFrame ();

    mr->remove (di);
    di = mr->add (robot);
    di->rotateTo (90);
    di->moveTo (0, GRID_SIZE);
    mr->add (new SWFAction ("stop ();"));
    mr->nextFrame ();

    mr->remove (di);
    di = mr->add (robot);
    di->rotateTo (180);
    di->moveTo (GRID_SIZE, GRID_SIZE);
    mr->add (new SWFAction ("stop ();"));
    mr->nextFrame ();

    mr->remove (di);
    di = mr->add (robot);
    di->rotateTo (-90);
    di->moveTo (GRID_SIZE, 0);
    mr->add (new SWFAction ("stop ();"));
    mr->nextFrame ();

    return mr;
}

/**************************************************************************
 *** une case
 **************************************************************************/
SWFSprite *
a_cell (int r, int g, int b)
{
    SWFSprite *kase = new SWFSprite ();

    SWFShape *s = new SWFShape ();

    s->setRightFill (s->addSolidFill (r, g, b));
    s->movePenTo   (GRID_SIZE / 2, GRID_SIZE / 2);
    s->drawLineTo  (GRID_SIZE / 2, -GRID_SIZE / 2);
    s->drawLineTo (-GRID_SIZE / 2, -GRID_SIZE / 2);
    s->drawLineTo (-GRID_SIZE / 2, GRID_SIZE / 2);
    s->drawLineTo  (GRID_SIZE / 2, GRID_SIZE / 2);

    SWFDisplayItem *di = kase->add (s);

    for (int i = 1; i <= ANIM_STEPS; i++)
    {
        di->rotateTo ( (i - ANIM_STEPS) * (-10) );
        di->scaleTo ((float) i / ANIM_STEPS, (float) i / ANIM_STEPS);
        if (i == ANIM_STEPS)
          kase->add (new SWFAction ("stop ();"));
        kase->nextFrame ();
    }
    return kase;
}

/**************************************************************************
 *** le drapeau
 **************************************************************************/
SWFSprite *
the_flag ()
{
    SWFSprite *d = new SWFSprite ();
    SWFFill *f;

    SWFShape *s = new SWFShape ();
    s->setLine (2, 190, 170, 30);
    s->drawLine (0, 20);
    s->setLine (2, 120, 110, 70);
    s->movePenTo (0, 0);
    s->drawLine (0, 9);
    d->add (s);

    const float e = 0.5;
    const float l = 3;

#define RECT \
    s->drawLine (l, 0); \
    s->drawLine (0, l); \
    s->drawLine (-l, 0); \
    s->drawLine (0, -l); 

#define DESC_RECT \
    s->drawCurve (l / 2 - 0.5, 0, 0.5, e); \
    s->drawCurve (0.5, e, l / 2 - 0.5, 0); \
    s->drawLine (0, l); \
    s->drawCurve (-l / 2 + 0.5, 0, -0.5, -e); \
    s->drawCurve (-0.5, -e, -l / 2 + 0.5, 0); \
    s->drawLine (0, -l);

#define ASC_RECT \
    s->drawCurve (l / 2 - 0.5, 0, 0.5, -e); \
    s->drawCurve (0.5, -e, l / 2 - 0.5, 0); \
    s->drawLine (0, l); \
    s->drawCurve (-l / 2 + 0.5, 0, -0.5, e); \
    s->drawCurve (-0.5, e, -l / 2 + 0.5, 0); \
    s->drawLine (0, -l);
    
    s = new SWFShape ();
    f = s->addSolidFill (240, 240, 240);
    s->setLeftFill (f);
    s->movePenTo (0, 0); RECT;
    s->movePenTo (0, 2 * l); RECT;
    s->movePenTo (l, l); DESC_RECT;
    s->movePenTo (2 * l, 2 * e); ASC_RECT;
    s->movePenTo (2 * l, 2 * l + 2 * e); ASC_RECT;
    s->movePenTo (3 * l, l); RECT;

    f = s->addSolidFill (0, 0, 0);
    s->setLeftFill (f);
    s->movePenTo (0, l); RECT;
    s->movePenTo (l, 0); DESC_RECT;
    s->movePenTo (l, 2 * l); DESC_RECT;
    s->movePenTo (2 * l, l + 2 * e); ASC_RECT;
    s->movePenTo (3 * l, 0); RECT;
    s->movePenTo (3 * l, 2 * l); RECT;
    d->add (s);

    s = new SWFShape ();
    s->setLine (0, 40, 40, 40);
    s->movePen (0, -1);
    s->drawLine (1, 1);
    s->drawLine (l - 1, 0);
    s->drawCurve (l / 2 - 0.5, 0, 0.5,  e); s->drawCurve (0.5,  e, l / 2 - 0.5, 0);
    s->drawCurve (l / 2 - 0.5, 0, 0.5, -e); s->drawCurve (0.5, -e, l / 2 - 0.5, 0);
    s->drawLine (l, 0);
    s->drawLine (0, 3 * l);
    s->drawLine (-l, 0);
    s->drawCurve (-l / 2 + 0.5, 0, -0.5,  e); s->drawCurve (-0.5,  e, -l / 2 + 0.5, 0);
    s->drawCurve (-l / 2 + 0.5, 0, -0.5, -e); s->drawCurve (-0.5, -e, -l / 2 + 0.5, 0);
    s->drawLine (-l + 1, 0);
    s->drawLine (0, 11);
    s->drawLine (-1, 1);
    s->drawLine (-1, -1);
    s->drawLine (0, -20);
    s->drawLine (1, -1);
    d->add (s);

    d->nextFrame ();
    return d;
}

/**************************************************************************
 *** la grille
 **************************************************************************/
SWFSprite *
the_grid (int l, int h)
{
    SWFSprite *grid = new SWFSprite ();
    SWFSprite *kase;
    SWFDisplayItem *di;
    char name[ 80 ];

    SWFSprite *robot = the_robot ();
    di = grid->add (robot);
    di->setName ("robot");
    di->setDepth (4);

    SWFSprite *flag = the_flag ();
    di = grid->add (flag);
    di->setName ("flag");
    di->setDepth (4);

    SWFSprite *arrows = new SWFSprite ();
    SWFSprite *arrow;

    for (int j = 0; j < h; j++)
    {
        for (int i = 0; i < l; i++)
        {
            kase = a_cell (0, 255, 0);
            di = grid->add (kase);
            di->moveTo (GRID_SIZE / 2 + i * GRID_SIZE, 
                        GRID_SIZE / 2 + j * GRID_SIZE);
            snprintf (name, 79, "cell_%d", i + j * l);
            di->setName (name);
            di->setDepth (2);

            arrow = an_arrow ();
            di = arrows->add (arrow);
            di->move (GRID_SIZE / 2 + i * GRID_SIZE, 
                      GRID_SIZE / 2 + j * GRID_SIZE);
            snprintf (name, 79, "arrow_%d", i + j * l);
            di->setName (name);
            di->setDepth (3);
        }
    }

    arrows->nextFrame ();
    di = grid->add (arrows);
    di->setName ("arrows");

    grid->add (new SWFAction ("\n\
robot._visible = false;\n\
flag._visible = false;\n\
arrows._visible = false;\n\
"));
    
    for (int i = 0; i < ANIM_STEPS; i++)
      grid->nextFrame ();

    SWFShape *g = new SWFShape ();
    g->setLine (1, 127, 127, 127);
    for (int i = 0; i <= l; i++)
    {
        g->movePenTo (i * GRID_SIZE, 0);
        g->drawLine (0, h * GRID_SIZE);
    }
    for (int j = 0; j <= h; j++)
    {
        g->movePenTo (0, j * GRID_SIZE);
        g->drawLine (l * GRID_SIZE, 0);
    }
    di = grid->add (g);
    di->setDepth (3);

    grid->add (new SWFAction ("\n\
robot._visible = true;\n\
flag._visible = true;\n\
stop ();"));
    grid->nextFrame ();

    return grid;
}

/**************************************************************************
 *** ce que le robot voit
 **************************************************************************/
SWFSprite *
vision_robot ()
{
    const int size = 44;

    SWFDisplayItem *di;
    SWFSprite *s = new SWFSprite ();
    SWFSprite *t = new SWFSprite ();

    SWFShape *b = new SWFShape ();
    b->setLine (6, 127, 127, 127);
    b->movePen (0, 2);
    b->drawLine (0, size - 4);

    t->add (b);
    t->nextFrame ();

    di = s->add (t);
    di->setName ("wall0");
    di->move (size, 0);

    di = s->add (t);
    di->setName ("wall1");
    di->rotate (90);

    di = s->add (t);
    di->setName ("wall2");

    di = s->add (t);
    di->setName ("wall3");
    di->rotate (90);
    di->move (0, size);

    b = new SWFShape ();
    b->setLine (2, 255, 255, 255);
    b->movePen (-3, -3);
    b->drawLine (size + 6, size + 6);
    b->movePenTo (size + 3, -3);
    b->drawLine (-size - 6, size + 6);
    s->add (b);

    SWFText *ok = new SWFText ();
    SWFFont *font = new SWFFont ("Helmet-Bold.fdb");
    ok->setFont (font);
    ok->setColor (30, 160, 0);
    ok->setHeight (12);
    ok->addString ("OK");
    t = new SWFSprite ();
    t->add (ok);
    SWFShape *f = new SWFShape (); // frame
    f->setLine (1, 30, 160, 0);
    f->drawLine (2 + ok->getWidth ("OK"), 0);
    f->drawLine (0, 11);
    f->drawLine (-2 - ok->getWidth ("OK"), 0);
    f->drawLine (0, -11);
    di = t->add (f);
    di->move (-1, -10);
    t->nextFrame ();
    di = s->add (t);
    di->move ((size - ok->getWidth ("OK")) / 2, 18);
    di->setName ("go");

    SWFText *bump = new SWFText ();
    bump->setFont (font);
    bump->setColor (200, 0, 0);
    bump->setHeight (12);
    bump->addString ("BUMP");
    t = new SWFSprite ();
    t->add (bump);
    f = new SWFShape (); // frame
    f->setLine (1, 200, 0, 0);
    f->drawLine (2 + bump->getWidth ("BUMP"), 0);
    f->drawLine (0, 11);
    f->drawLine (-2 - bump->getWidth ("BUMP"), 0);
    f->drawLine (0, -11);
    di = t->add (f);
    di->move (-1, -10);
    t->nextFrame ();
    di = s->add (t);
    di->move ((size - bump->getWidth ("BUMP")) / 2, 34);
    di->setName ("bump");

    s->nextFrame ();

    return s;
}

/**************************************************************************
 *** La barre de progression dans son popup
 **************************************************************************/
SWFSprite *
progress_popup (const char *text)
{
    SWFDisplayItem *di;
    SWFSprite       *p = new SWFSprite ();

    SWFShape *bg = a_rectangle (300, 140, 100, 0, 0);
    p->add (bg);
    
    bg = a_rectangle (296, 136, 255, 255, 240);
    di = p->add (bg);
    di->move (2, 2);
    
    SWFTextField *tf = new SWFTextField ();
    tf->setFlags (SWFTEXTFIELD_NOEDIT |
                  SWFTEXTFIELD_WORDWRAP |
                  SWFTEXTFIELD_MULTILINE |
                  SWFTEXTFIELD_NOSELECT);
    SWFFont *f = new SWFFont ("_serif");
    tf->setFont (f);
    tf->setBounds (260, 60);
    tf->setHeight (12);
    tf->setVariableName ("progress_text");
    di = p->add (tf);
    di->move (20, 20);

    char action[1000];
    snprintf (action, sizeof action, "progress_text = \"%s\";", text);
    p->add (new SWFAction (action));

    SWFShape *bar = a_rectangle (260, 20, 255, 255, 255);
    di = p->add (bar);
    di->move (20, 100);

    bar = a_rectangle (260, 20, 100, 50, 255);
    SWFSprite *sbar = new SWFSprite ();
    sbar->add (bar);
    sbar->nextFrame ();

    di = p->add (sbar);
    di->move (20, 100);
    di->setName ("bar");
    p->add (new SWFAction ("bar._xscale = 0;stop();"));

    p->nextFrame ();

    return p;
}

SWFSprite *
an_arrow (int direction)
{
    SWFSprite *arrow = new SWFSprite ();

    SWFShape *s = new SWFShape ();
    s->setLine (1, 0, 0, 127, 100);
    s->movePenTo (-GRID_SIZE / 3, 0);
    s->drawLine (2 * GRID_SIZE / 3, 0);
    s->drawLine (-4, -6);
    s->drawLine (2, 6);
    s->drawLine (-2, 6);
    s->drawLine (4, -6);

    SWFDisplayItem *di = arrow->add (s);
    di->rotate (direction * 90);

    arrow->nextFrame ();
    return arrow;
}
